#include <sourcemod>
#include <csgoranks>
#include <vip_core>

#pragma newdecls  required
#pragma semicolon 1

stock const char    g_szVIPFunction[]   = "CompetitiveRank";

public Plugin myinfo = {
    description = "Set a rank for VIP",
    version     = "1.0.0.0",
    author      = "CrazyHackGUT aka Kruzya",
    name        = "[VIP] CSGO Competitive Rank",
    url         = "https://kruzefag.ru/"
};

public APLRes AskPluginLoad2(Handle hMySelf, bool bLate, char[] szError, int iMaxLength) {
    if (GetEngineVersion() != Engine_CSGO) {
        strcopy(szError, iMaxLength, "Plugin works only in CS:GO!");
    }
}

public void OnPluginStart() {
    if (VIP_IsVIPLoaded()) {
        VIP_OnVIPLoaded();
    }
}

public int VIP_OnVIPLoaded() {
    VIP_RegisterFeature(g_szVIPFunction, INT, HIDE);
}

public int VIP_OnClientLoaded(int iClient, bool bIsVIP) {
    if (!bIsVIP || !IsCompetitiveRankWorking() || !VIP_IsClientFeatureUse(iClient, g_szVIPFunction)) {
        return;
    }

    CompetitiveGORank eRank = view_as<CompetitiveGORank>(VIP_GetClientFeatureInt(iClient, g_szVIPFunction));
    if (eRank < NoRank || eRank > GlobalElite) {
        LogError("[VIP - Competitive Rank] Invalid Competitive Rank ID!");
        return;
    }

    SetPlayerCompetitiveRank(iClient, eRank);
}

public int VIP_OnVIPClientRemoved(int iClient, const char[] szReason) {
    SetPlayerCompetitiveRank(iClient, NoRank);
}